# AVLTree | data-structure-typed
Documentation for data-structure-typed

# Class AVLTree<N>

#### Type Parameters

- #### N extends AVLTreeNode <N["val"], N> = AVLTreeNode

#### Hierarchy

- BST <N>
  - AVLTree
    - TreeMultiset

#### Implements

- IAVLTree <N>

- Defined in src/data-structures/binary-tree/avl-tree.ts:21

#####
Index

### Constructors

constructor

### Properties

_comparator

### Accessors

loopType
root
size
visitedId
visitedLeftSum
visitedNode
visitedVal

### Methods

BFS
DFS
DFSIterative
_accumulatedByPropertyName
_addTo
_balanceFactor
_balanceLL
_balanceLR
_balancePath
_balanceRL
_balanceRR
_clearResults
_compare
_getResultByPropertyName
_pushByPropertyNameStopOrNot
_setLoopType
_setRoot
_setSize
_setVisitedId
_setVisitedLeftSum
_setVisitedNode
_setVisitedVal
_updateHeight
add
addMany
allGreaterNodesAdd
clear
createNode
fill
get
getDepth
getHeight
getLeftMost
getMinHeight
getNodes
getPathToRoot
getPredecessor
getRightMost
getSubTreeSize
has
isAVLBalanced
isBST
isEmpty
isPerfectlyBalanced
isSubtreeBST
lastKey
lesserSum
levelIterative
listLevels
morris
perfectlyBalance
remove
subTreeAdd
subTreeSum
swapLocation

## Constructors

### constructor

- new AVLTree<N>(options?): AVLTree <N>

- This is a constructor function for an AVL tree data structure in TypeScript.

  #### Type Parameters

  - #### N extends AVLTreeNode <N["val"], N, N> = AVLTreeNode <any, AVLTreeNodeNested <any>>

  #### Parameters

  - ##### `Optional` options: AVLTreeOptions

    The `options` parameter is an optional object that can be passed to the constructor of the AVLTree class. It allows you to customize the behavior of the AVL tree by providing different options.

  #### Returns AVLTree <N>

  Overrides BST.constructor

  - Defined in src/data-structures/binary-tree/avl-tree.ts:28

## Properties

### `Protected` _comparator

_comparator: BSTComparator = ...

Inherited from BST._comparator

- Defined in src/data-structures/binary-tree/bst.ts:519

## Accessors

### loopType

- get loopType(): LoopType

- #### Returns LoopType

  Implementation of IAVLTree.loopType

  Inherited from BST.loopType

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:168

### root

- get root(): null | N

- #### Returns null | N

  Implementation of IAVLTree.root

  Inherited from BST.root

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:156

### size

- get size(): number

- #### Returns number

  Implementation of IAVLTree.size

  Inherited from BST.size

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:162

### visitedId

- get visitedId(): number[]

- #### Returns number[]

  Implementation of IAVLTree.visitedId

  Inherited from BST.visitedId

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:174

### visitedLeftSum

- get visitedLeftSum(): number[]

- #### Returns number[]

  Implementation of IAVLTree.visitedLeftSum

  Inherited from BST.visitedLeftSum

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:192

### visitedNode

- get visitedNode(): N[]

- #### Returns N[]

  Implementation of IAVLTree.visitedNode

  Inherited from BST.visitedNode

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:186

### visitedVal

- get visitedVal(): N["val"][]

- #### Returns N["val"][]

  Implementation of IAVLTree.visitedVal

  Inherited from BST.visitedVal

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:180

## Methods

### BFS

- BFS(): number[]

- Performs a breadth-first search (BFS) on a binary tree, accumulating properties of each node based on their 'id' property.

  #### Returns number[]

  An array of binary tree node IDs.

  Implementation of IAVLTree.BFS

  Inherited from BST.BFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:929
- BFS(nodeOrPropertyName): number[]

- Performs a breadth-first search (BFS) on a binary tree, accumulating properties of each node based on the specified property name.

  #### Parameters

  - ##### nodeOrPropertyName: "id"

    The name of the property to accumulate.

  #### Returns number[]

  An array of values corresponding to the specified property.

  Implementation of IAVLTree.BFS

  Inherited from BST.BFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:936
- BFS(nodeOrPropertyName): N["val"][]

- Performs a breadth-first search (BFS) on a binary tree, accumulating the 'val' property of each node.

  #### Parameters

  - ##### nodeOrPropertyName: "val"

    The name of the property to accumulate.

  #### Returns N["val"][]

  An array of 'val' properties from each node.

  Implementation of IAVLTree.BFS

  Inherited from BST.BFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:943
- BFS(nodeOrPropertyName): N[]

- Performs a breadth-first search (BFS) on a binary tree, accumulating nodes themselves.

  #### Parameters

  - ##### nodeOrPropertyName: "node"

    The name of the property to accumulate.

  #### Returns N[]

  An array of binary tree nodes.

  Implementation of IAVLTree.BFS

  Inherited from BST.BFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:950

### DFS

- DFS(): number[]

- Performs a depth-first search (DFS) traversal on a binary tree and accumulates properties of each node based on their 'id' property.

  #### Returns number[]

  An array of binary tree node IDs.

  Implementation of IAVLTree.DFS

  Inherited from BST.DFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:980
- DFS(pattern?, nodeOrPropertyName?): number[]

- Performs a depth-first search (DFS) traversal on a binary tree and accumulates properties of each node based on the specified property name.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "id"

    The name of the property to accumulate.

  #### Returns number[]

  An array of values corresponding to the specified property.

  Implementation of IAVLTree.DFS

  Inherited from BST.DFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:988
- DFS(pattern?, nodeOrPropertyName?): N[]

- Performs a depth-first search (DFS) traversal on a binary tree and accumulates the 'val' property of each node.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "val"

    The name of the property to accumulate.

  #### Returns N[]

  An array of 'val' properties from each node.

  Implementation of IAVLTree.DFS

  Inherited from BST.DFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:996
- DFS(pattern?, nodeOrPropertyName?): N[]

- Performs a depth-first search (DFS) traversal on a binary tree and accumulates nodes themselves.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "node"

    The name of the property to accumulate.

  #### Returns N[]

  An array of binary tree nodes.

  Implementation of IAVLTree.DFS

  Inherited from BST.DFS

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1004

### DFSIterative

- DFSIterative(): number[]

- Performs an iterative depth-first search (DFS) traversal on a binary tree and accumulates properties of each node based on their 'id' property.

  #### Returns number[]

  An array of binary tree node IDs.

  Implementation of IAVLTree.DFSIterative

  Inherited from BST.DFSIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1047
- DFSIterative(pattern?, nodeOrPropertyName?): number[]

- Performs an iterative depth-first search (DFS) traversal on a binary tree and accumulates properties of each node based on the specified property name.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "id"

    The name of the property to accumulate.

  #### Returns number[]

  An array of values corresponding to the specified property.

  Implementation of IAVLTree.DFSIterative

  Inherited from BST.DFSIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1055
- DFSIterative(pattern?, nodeOrPropertyName?): N[]

- Performs an iterative depth-first search (DFS) traversal on a binary tree and accumulates the 'val' property of each node.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "val"

    The name of the property to accumulate.

  #### Returns N[]

  An array of 'val' properties from each node.

  Implementation of IAVLTree.DFSIterative

  Inherited from BST.DFSIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1063
- DFSIterative(pattern?, nodeOrPropertyName?): N[]

- Performs an iterative depth-first search (DFS) traversal on a binary tree and accumulates nodes themselves.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "node"

    The name of the property to accumulate.

  #### Returns N[]

  An array of binary tree nodes.

  Implementation of IAVLTree.DFSIterative

  Inherited from BST.DFSIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1071

### `Protected` _accumulatedByPropertyName

- _accumulatedByPropertyName(node, nodeOrPropertyName?): void

- The function `_accumulatedByPropertyName` accumulates values from a given node based on the specified property name.

  #### Parameters

  - ##### node: N

    The `node` parameter is of type `N`, which represents a node in a data structure.

  - ##### `Optional` nodeOrPropertyName: NodeOrPropertyName

    The `nodeOrPropertyName` parameter is an optional parameter that can be either a string representing a property name or a reference to a `Node` object. If it is a string, it specifies the property name to be used for accumulating values. If it is a `Node` object, it specifies

  #### Returns void

  Inherited from BST._accumulatedByPropertyName

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1584

### `Protected` _addTo

- _addTo(newNode, parent): undefined | null | N

- The function adds a new node to a binary tree if there is an available position.

  #### Parameters

  - ##### newNode: null | N

    The `newNode` parameter is of type `N | null`, which means it can either be a node of type `N` or `null`. It represents the node that you want to add to the binary tree.

  - ##### parent: N

    The parent parameter is of type N, which represents a node in a binary tree.

  #### Returns undefined | null | N

  either the left or right child node of the parent node, depending on which child is available for adding the new node. If a new node is added, the function also updates the size of the binary tree. If neither the left nor right child is available, the function returns undefined. If the parent node is null, the function also returns undefined.

  Inherited from BST._addTo

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1438

### `Protected` _balanceFactor

- _balanceFactor(node): number

- The balance factor of a given AVL tree node is calculated by subtracting the height of its left subtree from the height of its right subtree.

  #### Parameters

  - ##### node: N

    The parameter "node" is of type N, which represents a node in an AVL tree.

  #### Returns number

  The balance factor of the given AVL tree node.

  - Defined in src/data-structures/binary-tree/avl-tree.ts:84

### `Protected` _balanceLL

- _balanceLL(A): void

- The `_balanceLL` function performs a left-left rotation on an AVL tree to balance it.

  #### Parameters

  - ##### A: N

    The parameter A is an AVLTreeNode object.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:155

### `Protected` _balanceLR

- _balanceLR(A): void

- The `_balanceLR` function performs a left-right rotation to balance an AVL tree.

  #### Parameters

  - ##### A: N

    A is an AVLTreeNode object.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:185

### `Protected` _balancePath

- _balancePath(node): void

- The `_balancePath` function balances the AVL tree by performing appropriate rotations based on the balance factor of each node in the path from the given node to the root.

  #### Parameters

  - ##### node: N

    The `node` parameter is an AVLTreeNode object, which represents a node in an AVL tree.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:112

### `Protected` _balanceRL

- _balanceRL(A): void

- The `_balanceRL` function performs a right-left rotation to balance an AVL tree.

  #### Parameters

  - ##### A: N

    A is an AVLTreeNode object.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:268

### `Protected` _balanceRR

- _balanceRR(A): void

- The `_balanceRR` function performs a right-right rotation on an AVL tree to balance it.

  #### Parameters

  - ##### A: N

    The parameter A is an AVLTreeNode object.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:233

### `Protected` _clearResults

- _clearResults(): void

- The function `_clearResults` resets the values of several arrays used for tracking visited nodes and their properties.

  #### Returns void

  Inherited from BST._clearResults

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1526

### `Protected` _compare

- _compare(a, b): CP

- The function compares two binary tree node IDs using a comparator function and returns whether the first ID is greater than, less than, or equal to the second ID.

  #### Parameters

  - ##### a: number

    a is a BinaryTreeNodeId, which represents the identifier of a binary tree node.

  - ##### b: number

    The parameter "b" in the above code refers to a BinaryTreeNodeId.

  #### Returns CP

  a value of type CP (ComparisonResult). The possible return values are CP.gt (greater than), CP.lt (less than), or CP.eq (equal).

  Inherited from BST._compare

  - Defined in src/data-structures/binary-tree/bst.ts:529

### `Protected` _getResultByPropertyName

- _getResultByPropertyName(nodeOrPropertyName?): AbstractBinaryTreeNodeProperties <N>

- The function `_getResultByPropertyName` returns the corresponding property value based on the given node or property name.

  #### Parameters

  - ##### `Optional` nodeOrPropertyName: NodeOrPropertyName

    The parameter `nodeOrPropertyName` is an optional parameter that can accept either a `NodeOrPropertyName` type or be undefined.

  #### Returns AbstractBinaryTreeNodeProperties <N>

  The method `_getResultByPropertyName` returns an instance of `AbstractBinaryTreeNodeProperties<N>`.

  Inherited from BST._getResultByPropertyName

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1615

### `Protected` _pushByPropertyNameStopOrNot

- _pushByPropertyNameStopOrNot(cur, result, nodeProperty, propertyName?, onlyOne?): undefined | boolean

- The function checks if a given property of a binary tree node matches a specified value, and if so, adds the node to a result array.

  #### Parameters

  - ##### cur: N

    The current node being processed.

  - ##### result: (undefined | null | N)[]

    An array that stores the matching nodes.

  - ##### nodeProperty: number | N

    The `nodeProperty` parameter is either a `BinaryTreeNodeId` or a `N` type. It represents the property value that we are comparing against in the switch statement.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the property name to compare against when pushing nodes into the `result` array. It can be either `'id'` or `'val'`. If it is not provided or is not equal to `'id'` or `'val'`, the

  - ##### `Optional` onlyOne: boolean

    The `onlyOne` parameter is an optional boolean parameter that determines whether to stop after finding the first matching node or continue searching for all matching nodes. If `onlyOne` is set to `true`, the function will stop after finding the first matching node and return `true`. If `onlyOne

  #### Returns undefined | boolean

  a boolean value indicating whether only one matching node should be pushed into the result array.

  Inherited from BST._pushByPropertyNameStopOrNot

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1548

### `Protected` _setLoopType

- _setLoopType(value): void

- The function sets the loop type for a protected variable.

  #### Parameters

  - ##### value: LoopType

    The value parameter is of type LoopType.

  #### Returns void

  Inherited from BST._setLoopType

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1466

### `Protected` _setRoot

- _setRoot(v): void

- The function sets the root property of an object to a given value, and if the value is not null, it also sets the parent property of the value to undefined.

  #### Parameters

  - ##### v: null | N

    The parameter `v` is of type `N | null`, which means it can either be of type `N` or `null`.

  #### Returns void

  Inherited from BST._setRoot

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1507

### `Protected` _setSize

- _setSize(v): void

- The function sets the size of a protected variable.

  #### Parameters

  - ##### v: number

    number

  #### Returns void

  Inherited from BST._setSize

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1518

### `Protected` _setVisitedId

- _setVisitedId(value): void

- The function sets the value of the `_visitedId` property in a protected manner.

  #### Parameters

  - ##### value: number[]

    value is an array of BinaryTreeNodeId values.

  #### Returns void

  Inherited from BST._setVisitedId

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1474

### `Protected` _setVisitedLeftSum

- _setVisitedLeftSum(value): void

- The function sets the value of the `_visitedLeftSum` property to the provided array.

  #### Parameters

  - ##### value: number[]

    An array of numbers that represents the visited left sum.

  #### Returns void

  Inherited from BST._setVisitedLeftSum

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1498

### `Protected` _setVisitedNode

- _setVisitedNode(value): void

- The function sets the value of the _visitedNode property.

  #### Parameters

  - ##### value: N[]

    N[] is an array of elements of type N.

  #### Returns void

  Inherited from BST._setVisitedNode

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1490

### `Protected` _setVisitedVal

- _setVisitedVal(value): void

- The function sets the value of the "_visitedVal" property to the given array.

  #### Parameters

  - ##### value: N[]

    An array of type N.

  #### Returns void

  Inherited from BST._setVisitedVal

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1482

### `Protected` _updateHeight

- _updateHeight(node): void

- The function updates the height of a node in an AVL tree based on the heights of its left and right subtrees.

  #### Parameters

  - ##### node: N

    The parameter `node` is an AVLTreeNode object, which represents a node in an AVL tree.

  #### Returns void

  - Defined in src/data-structures/binary-tree/avl-tree.ts:98

### add

- add(id, val?): undefined | null | N

- The function overrides the add method of a binary tree node and balances the tree after inserting a new node.

  #### Parameters

  - ##### id: number

    The `id` parameter is the identifier of the binary tree node that we want to add.

  - ##### `Optional` val: N["val"]

    The `val` parameter is an optional value that can be assigned to the node being added. It is of type `N['val']`, which means it should be of the same type as the `val` property of the nodes in the binary tree.

  #### Returns undefined | null | N

  The method is returning the inserted node, or null or undefined if the insertion was not successful.

  Implementation of IAVLTree.add

  Overrides BST.add

  - Defined in src/data-structures/binary-tree/avl-tree.ts:51

### addMany

- addMany(idsOrNodes, data?, isBalanceAdd?): (undefined | null | N)[]

- The `addMany` function overrides the base class method to add multiple nodes to a binary search tree in a balanced manner.

  #### Parameters

  - ##### idsOrNodes: (null | number)[] | (null | N)[]

    The `idsOrNodes` parameter in the `addMany` function is an array of `BinaryTreeNodeId` or `N` (node) objects, or `null` values. It represents the nodes or node IDs that need to be added to the binary search tree.

  - ##### `Optional` data: N["val"][]

    The values of tree nodes

  - ##### isBalanceAdd: boolean = false

    If true the nodes will be balance inserted in binary search method.

  #### Returns (undefined | null | N)[]

  The function `addMany` returns an array of `N`, `null`, or `undefined` values.

  Implementation of IAVLTree.addMany

  Inherited from BST.addMany

  - Defined in src/data-structures/binary-tree/bst.ts:134

### allGreaterNodesAdd

- allGreaterNodesAdd(node, delta, propertyName?): boolean

- The `allGreaterNodesAdd` function adds a delta value to the specified property of all nodes in a binary tree that have a greater value than a given node.

  #### Parameters

  - ##### node: null | number | N

    The `node` parameter can be either of type `N` (a generic type), `BinaryTreeNodeId`, or `null`. It represents the node in the binary tree to which the delta value will be added.

  - ##### delta: number

    The `delta` parameter is a number that represents the amount by which the property value of each greater node should be increased.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the property name of the nodes in the binary tree that you want to update. If not provided, it defaults to 'id'.

  #### Returns boolean

  a boolean value.

  Implementation of IAVLTree.allGreaterNodesAdd

  Inherited from BST.allGreaterNodesAdd

  - Defined in src/data-structures/binary-tree/bst.ts:370

### clear

- clear(): void

- The clear() function resets the root, size, and maxId properties to their initial values.

  #### Returns void

  Implementation of IAVLTree.clear

  Inherited from BST.clear

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:227

### createNode

- createNode(id, val?): N

- The function creates a new AVL tree node with the given id and value.

  #### Parameters

  - ##### id: number

    The `id` parameter is the identifier for the binary tree node. It is used to uniquely identify each node in the tree.

  - ##### `Optional` val: N["val"]

    The `val` parameter is an optional value that can be assigned to the node. It represents the value that will be stored in the node.

  #### Returns N

  a new AVLTreeNode object with the specified id and value.

  Implementation of IAVLTree.createNode

  Overrides BST.createNode

  - Defined in src/data-structures/binary-tree/avl-tree.ts:40

### fill

- fill(idsOrNodes, data?): boolean

- The `fill` function clears the binary tree and adds multiple nodes with the given IDs or nodes and optional data.

  #### Parameters

  - ##### idsOrNodes: (null | number)[] | (null | N)[]

    The `idsOrNodes` parameter is an array that can contain either `BinaryTreeNodeId` or `N` values.

  - ##### `Optional` data: N[] | N["val"][]

    The `data` parameter is an optional array of values that will be assigned to the nodes being added. If provided, the length of the `data` array should be equal to the length of the `idsOrNodes` array. Each value in the `data` array will be assigned to the

  #### Returns boolean

  The method is returning a boolean value.

  Implementation of IAVLTree.fill

  Inherited from BST.fill

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:345

### get

- get(nodeProperty, propertyName?): null | N

- The function returns the first node in a binary tree that matches the given property name and value.

  #### Parameters

  - ##### nodeProperty: number | N

    The `nodeProperty` parameter can be either a `BinaryTreeNodeId` or a generic type `N`. It represents the property of the binary tree node that you want to search for.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the property name to use for searching the binary tree nodes. If not provided, it defaults to `'id'`.

  #### Returns null | N

  The method is returning either a BinaryTreeNodeId or N (generic type) or null.

  Implementation of IAVLTree.get

  Inherited from BST.get

  - Defined in src/data-structures/binary-tree/bst.ts:211

### getDepth

- getDepth(beginRoot): number

- The function calculates the depth of a node in a binary tree.

  #### Parameters

  - ##### beginRoot: null | number | N

    The `beginRoot` parameter can be one of the following:

  #### Returns number

  the depth of the given node or binary tree.

  Implementation of IAVLTree.getDepth

  Inherited from BST.getDepth

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:412

### getHeight

- getHeight(beginRoot?): number

- The `getHeight` function calculates the maximum height of a binary tree, either recursively or iteratively.

  #### Parameters

  - ##### `Optional` beginRoot: null | number | N

    The `beginRoot` parameter is optional and can be of type `N` (a generic type representing a node in a binary tree), `BinaryTreeNodeId` (a type representing the ID of a binary tree node), or `null`.

  #### Returns number

  the height of the binary tree.

  Implementation of IAVLTree.getHeight

  Inherited from BST.getHeight

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:430

### getLeftMost

- getLeftMost(): null | N

- The function `getLeftMost` returns the leftmost node in a binary tree, starting from a specified node or the root if no node is specified. generic type representing a node in a binary tree), `BinaryTreeNodeId` (a type representing the ID of a binary tree node), or `null`.

  #### Returns null | N

  The function `getLeftMost` returns the leftmost node in a binary tree. If the `beginRoot` parameter is provided, it starts the traversal from that node. If `beginRoot` is not provided or is `null`, it starts the traversal from the root of the binary tree. The function returns the leftmost node found during the traversal. If no leftmost node is found (

  Implementation of IAVLTree.getLeftMost

  Inherited from BST.getLeftMost

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:638
- getLeftMost(node?): N

- The function `getLeftMost` returns the leftmost node in a binary tree, starting from a specified node or the root if no node is specified.

  #### Parameters

  - ##### `Optional` node: N

    The `beginRoot` parameter is optional and can be of type `N` (a generic type representing a node in a binary tree), `BinaryTreeNodeId` (a type representing the ID of a binary tree node).

  #### Returns N

  The function `getLeftMost` returns the leftmost node in a binary tree. If the `beginRoot` parameter is provided, it starts the traversal from that node. If `beginRoot` is not provided or is `null`, it starts the traversal from the root of the binary tree. The function returns the leftmost node found during the traversal. If no leftmost node is found (

  Implementation of IAVLTree.getLeftMost

  Inherited from BST.getLeftMost

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:651

### getMinHeight

- getMinHeight(beginRoot?): number

- The `getMinHeight` function calculates the minimum height of a binary tree using either a recursive or iterative approach.

  #### Parameters

  - ##### `Optional` beginRoot: null | N

    The `beginRoot` parameter is an optional parameter of type `N` or `null`. It represents the starting node from which to calculate the minimum height of a binary tree. If no value is provided for `beginRoot`, the `this.root` property is used as the default value.

  #### Returns number

  The function `getMinHeight` returns the minimum height of the binary tree.

  Implementation of IAVLTree.getMinHeight

  Inherited from BST.getMinHeight

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:479

### getNodes

- getNodes(nodeProperty, propertyName?, onlyOne?): N[]

- The function `getNodes` returns an array of nodes in a binary tree that match a given property value.

  #### Parameters

  - ##### nodeProperty: number | N

    The `nodeProperty` parameter can be either a `BinaryTreeNodeId` or an `N` type. It represents the property of the binary tree node that you want to compare with.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName = 'id'

    The `propertyName` parameter is an optional parameter that specifies the property name to use for comparison. If not provided, it defaults to `'id'`.

  - ##### `Optional` onlyOne: boolean

    The `onlyOne` parameter is an optional boolean parameter that determines whether to return only one node that matches the given `nodeProperty` or all nodes that match the `nodeProperty`. If `onlyOne` is set to `true`, the function will return an array with only one node (if

  #### Returns N[]

  an array of nodes (type N).

  Implementation of IAVLTree.getNodes

  Inherited from BST.getNodes

  - Defined in src/data-structures/binary-tree/bst.ts:240

### getPathToRoot

- getPathToRoot(node, isReverse?): N[]

- The function `getPathToRoot` returns an array of nodes representing the path from a given node to the root node, with an option to reverse the order of the nodes.

  #### Parameters

  - ##### node: N

    The `node` parameter represents a node in a tree structure. It is of type `N`, which could be any type that represents a node in your specific implementation.

  - ##### `Optional` isReverse: boolean = true

    The `isReverse` parameter is a boolean flag that determines whether the resulting path should be reversed or not. If `isReverse` is set to `true`, the path will be reversed before returning it. If `isReverse` is set to `false` or not provided, the path will

  #### Returns N[]

  The function `getPathToRoot` returns an array of nodes (`N[]`).

  Implementation of IAVLTree.getPathToRoot

  Inherited from BST.getPathToRoot

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:615

### getPredecessor

- getPredecessor(node): N

- The function returns the predecessor of a given node in a binary tree.

  #### Parameters

  - ##### node: N

    The parameter `node` is a BinaryTreeNode object, representing a node in a binary tree.

  #### Returns N

  the predecessor of the given node in a binary tree.

  Implementation of IAVLTree.getPredecessor

  Inherited from BST.getPredecessor

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1284

### getRightMost

- getRightMost(): null | N

- The `getRightMost` function returns the rightmost node in a binary tree, either recursively or iteratively using tail recursion optimization.

  #### Returns null | N

  The `getRightMost` function returns the rightmost node in a binary tree. It returns the rightmost node starting from the root of the binary tree.

  Implementation of IAVLTree.getRightMost

  Inherited from BST.getRightMost

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:694
- getRightMost(node?): N

- The `getRightMost` function returns the rightmost node in a binary tree, either recursively or iteratively using tail recursion optimization.

  #### Parameters

  - ##### `Optional` node: N

    The `node` parameter is an optional parameter of type `N` or `null`. It represents the starting node from which we want to find the rightmost node. If no node is provided, the function will default to using the root node of the data structure.

  #### Returns N

  The `getRightMost` function returns the rightmost node in a binary tree. It returns the rightmost node starting from that node.

  Implementation of IAVLTree.getRightMost

  Inherited from BST.getRightMost

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:705

### getSubTreeSize

- getSubTreeSize(subTreeRoot): number

- The function calculates the size of a subtree by traversing it either recursively or iteratively.

  #### Parameters

  - ##### subTreeRoot: undefined | null | N

    The `subTreeRoot` parameter represents the root node of a subtree in a binary tree.

  #### Returns number

  the size of the subtree rooted at `subTreeRoot`.

  Implementation of IAVLTree.getSubTreeSize

  Inherited from BST.getSubTreeSize

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:789

### has

- has(nodeProperty, propertyName?): boolean

- The function checks if a binary tree node has a specific property.

  #### Parameters

  - ##### nodeProperty: number | N

    The `nodeProperty` parameter can be either a `BinaryTreeNodeId` or `N`. It represents the property of the binary tree node that you want to check.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the name of the property to be checked in the nodes. If not provided, it defaults to 'id'.

  #### Returns boolean

  a boolean value.

  Implementation of IAVLTree.has

  Inherited from BST.has

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:582

### isAVLBalanced

- isAVLBalanced(): boolean

- The function `isAVLBalanced` checks if a binary tree is balanced according to the AVL tree property.

  #### Returns boolean

  a boolean value.

  Implementation of IAVLTree.isAVLBalanced

  Inherited from BST.isAVLBalanced

  - Defined in src/data-structures/binary-tree/bst.ts:475

### isBST

- isBST(): boolean

- The function isBST checks if the binary tree is valid binary search tree.

  #### Returns boolean

  The `isBST()` function is returning a boolean value.

  Implementation of IAVLTree.isBST

  Inherited from BST.isBST

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:779

### isEmpty

- isEmpty(): boolean

- The function checks if the size of an object is equal to zero and returns a boolean value.

  #### Returns boolean

  A boolean value indicating whether the size of the object is 0 or not.

  Implementation of IAVLTree.isEmpty

  Inherited from BST.isEmpty

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:237

### isPerfectlyBalanced

- isPerfectlyBalanced(beginRoot?): boolean

- The function checks if a binary tree is perfectly balanced by comparing the minimum height and the height of the tree.

  #### Parameters

  - ##### `Optional` beginRoot: null | N

    The parameter `beginRoot` is of type `N` or `null`. It represents the root node of a tree or null if the tree is empty.

  #### Returns boolean

  The method is returning a boolean value.

  Implementation of IAVLTree.isPerfectlyBalanced

  Inherited from BST.isPerfectlyBalanced

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:529

### isSubtreeBST

- isSubtreeBST(node): boolean

- The function checks if a binary search tree is valid by traversing it either recursively or iteratively.

  #### Parameters

  - ##### node: null | N

    The `node` parameter represents the root node of a binary search tree (BST).

  #### Returns boolean

  a boolean value.

  Implementation of IAVLTree.isSubtreeBST

  Inherited from BST.isSubtreeBST

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:745

### lastKey

- lastKey(): number

- The function returns the id of the rightmost node if the comparison between two values is less than, the id of the leftmost node if the comparison is greater than, and the id of the rightmost node otherwise.

  #### Returns number

  The method `lastKey()` returns the id of the rightmost node in the binary tree if the comparison between the values at index 0 and 1 is less than, otherwise it returns the id of the leftmost node. If the comparison is equal, it returns the id of the rightmost node. If there are no nodes in the tree, it returns 0.

  Implementation of IAVLTree.lastKey

  Inherited from BST.lastKey

  - Defined in src/data-structures/binary-tree/bst.ts:223

### lesserSum

- lesserSum(beginNode, propertyName?): number

- The `lesserSum` function calculates the sum of property values in a binary tree for nodes that have a property value less than a given node.

  #### Parameters

  - ##### beginNode: null | number | N

    The `beginNode` parameter can be one of the following:

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the property name to use for calculating the sum. If not provided, it defaults to `'id'`.

  #### Returns number

  The function `lesserSum` returns a number, which represents the sum of the values of the nodes in the binary tree that have a lesser value than the specified `beginNode` based on the `propertyName`.

  Implementation of IAVLTree.lesserSum

  Inherited from BST.lesserSum

  - Defined in src/data-structures/binary-tree/bst.ts:293

### levelIterative

- levelIterative(node): number[]

- Performs a level-order traversal on a binary tree starting from the specified node and accumulates properties of each node based on their 'id' property.

  #### Parameters

  - ##### node: null | N

    The starting node for the level order traversal. If null, the root node of the tree is used as the starting node.

  #### Returns number[]

  An array of binary tree node IDs.

  Implementation of IAVLTree.levelIterative

  Inherited from BST.levelIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1130
- levelIterative(node, nodeOrPropertyName?): number[]

- Performs a level-order traversal on a binary tree starting from the specified node and accumulates properties of each node based on the specified property name.

  #### Parameters

  - ##### node: null | N

    The starting node for the level order traversal. If null, the root node of the tree is used as the starting node.

  - ##### `Optional` nodeOrPropertyName: "id"

    The name of the property to accumulate.

  #### Returns number[]

  An array of values corresponding to the specified property.

  Implementation of IAVLTree.levelIterative

  Inherited from BST.levelIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1138
- levelIterative(node, nodeOrPropertyName?): N["val"][]

- Performs a level-order traversal on a binary tree starting from the specified node and accumulates the 'val' property of each node.

  #### Parameters

  - ##### node: null | N

    The starting node for the level order traversal. If null, the root node of the tree is used as the starting node.

  - ##### `Optional` nodeOrPropertyName: "val"

    The name of the property to accumulate.

  #### Returns N["val"][]

  An array of 'val' properties from each node.

  Implementation of IAVLTree.levelIterative

  Inherited from BST.levelIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1146
- levelIterative(node, nodeOrPropertyName?): N[]

- Performs a level-order traversal on a binary tree starting from the specified node and accumulates nodes themselves.

  #### Parameters

  - ##### node: null | N

    The starting node for the level order traversal. If null, the root node of the tree is used as the starting node.

  - ##### `Optional` nodeOrPropertyName: "node"

    The name of the property to accumulate.

  #### Returns N[]

  An array of binary tree nodes.

  Implementation of IAVLTree.levelIterative

  Inherited from BST.levelIterative

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1154

### listLevels

- listLevels(node): number[][]

- Collects nodes from a binary tree by a specified property and organizes them into levels.

  #### Parameters

  - ##### node: null | N

    The root node of the binary tree or null. If null, the function will use the root node of the current binary tree instance.

  #### Returns number[][]

  A 2D array of AbstractBinaryTreeNodeProperty<N> objects.

  Implementation of IAVLTree.listLevels

  Inherited from BST.listLevels

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1197
- listLevels(node, nodeOrPropertyName?): number[][]

- Collects nodes from a binary tree by a specified property and organizes them into levels.

  #### Parameters

  - ##### node: null | N

    The root node of the binary tree or null. If null, the function will use the root node of the current binary tree instance.

  - ##### `Optional` nodeOrPropertyName: "id"

  #### Returns number[][]

  Implementation of IAVLTree.listLevels

  Inherited from BST.listLevels

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1205
- listLevels(node, nodeOrPropertyName?): N["val"][][]

- Collects nodes from a binary tree by a specified property and organizes them into levels.

  #### Parameters

  - ##### node: null | N

    The root node of the binary tree or null. If null, the function will use the root node of the current binary tree instance.

  - ##### `Optional` nodeOrPropertyName: "val"

    The property of the BinaryTreeNode object to collect at each level.

  #### Returns N["val"][][]

  A 2D array of 'val' properties from each node.

  Implementation of IAVLTree.listLevels

  Inherited from BST.listLevels

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1213
- listLevels(node, nodeOrPropertyName?): N[][]

- Collects nodes from a binary tree by a specified property and organizes them into levels.

  #### Parameters

  - ##### node: null | N

    The root node of the binary tree or null. If null, the function will use the root node of the current binary tree instance.

  - ##### `Optional` nodeOrPropertyName: "node"

    The property of the BinaryTreeNode object to collect at each level.

  #### Returns N[][]

  A 2D array of binary tree nodes.

  Implementation of IAVLTree.listLevels

  Inherited from BST.listLevels

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1221

### morris

- morris(): number[]

- Performs an in-order, pre-order, or post-order traversal on a binary tree using the Morris traversal algorithm.

  #### Returns number[]

  An array of binary tree node IDs.

  Implementation of IAVLTree.morris

  Inherited from BST.morris

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1307
- morris(pattern?, nodeOrPropertyName?): number[]

- Performs an in-order, pre-order, or post-order traversal on a binary tree using the Morris traversal algorithm and accumulates properties of each node based on the specified property name.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "id"

    The name of the property to accumulate.

  #### Returns number[]

  An array of values corresponding to the specified property.

  Implementation of IAVLTree.morris

  Inherited from BST.morris

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1315
- morris(pattern?, nodeOrPropertyName?): N[]

- Performs an in-order, pre-order, or post-order traversal on a binary tree using the Morris traversal algorithm and accumulates the 'val' property of each node.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "val"

    The property of the BinaryTreeNode object to collect at each level.

  #### Returns N[]

  An array of 'val' properties from each node.

  Implementation of IAVLTree.morris

  Inherited from BST.morris

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1323
- morris(pattern?, nodeOrPropertyName?): N[]

- Performs an in-order, pre-order, or post-order traversal on a binary tree using the Morris traversal algorithm and accumulates nodes themselves.

  #### Parameters

  - ##### `Optional` pattern: DFSOrderPattern

    The traversal pattern: 'in' (in-order), 'pre' (pre-order), or 'post' (post-order).

  - ##### `Optional` nodeOrPropertyName: "node"

    The property of the BinaryTreeNode object to collect at each level.

  #### Returns N[]

  An array of binary tree nodes.

  Implementation of IAVLTree.morris

  Inherited from BST.morris

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:1331

### perfectlyBalance

- perfectlyBalance(): boolean

- The `perfectlyBalance` function takes a binary tree, performs a depth-first search to sort the nodes, and then constructs a balanced binary search tree using either a recursive or iterative approach.

  #### Returns boolean

  The function `perfectlyBalance()` returns a boolean value.

  Implementation of IAVLTree.perfectlyBalance

  Inherited from BST.perfectlyBalance

  - Defined in src/data-structures/binary-tree/bst.ts:434

### remove

- remove(id, isUpdateAllLeftSum?): BinaryTreeDeletedResult <N>[]

- The function overrides the remove method of the Binary Search Tree class, performs the removal operation, and then balances the tree if necessary.

  #### Parameters

  - ##### id: number

    The `id` parameter represents the identifier of the binary tree node that needs to be removed from the AVL tree.

  - ##### `Optional` isUpdateAllLeftSum: boolean

    The `isUpdateAllLeftSum` parameter is an optional boolean parameter that determines whether the left sum of all nodes in the AVL tree should be updated after removing a node. If `isUpdateAllLeftSum` is set to `true`, the left sum of all nodes will be recalculated.

  #### Returns BinaryTreeDeletedResult <N>[]

  The method is returning an array of `AVLTreeDeleted<N>` objects.

  Implementation of IAVLTree.remove

  Overrides BST.remove

  - Defined in src/data-structures/binary-tree/avl-tree.ts:68

### subTreeAdd

- subTreeAdd(subTreeRoot, delta, propertyName?): boolean

- The function `subTreeAdd` adds a delta value to a specified property of each node in a subtree.

  #### Parameters

  - ##### subTreeRoot: null | number | N

    The `subTreeRoot` parameter represents the root node of a binary tree or the ID of a node in the binary tree. It can also be `null` if there is no subtree to add to.

  - ##### delta: number

    The `delta` parameter is a number that represents the amount by which the property value of each node in the subtree should be incremented.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    The `propertyName` parameter is an optional parameter that specifies the property of the binary tree node that should be modified. If not provided, it defaults to 'id'.

  #### Returns boolean

  a boolean value.

  Implementation of IAVLTree.subTreeAdd

  Inherited from BST.subTreeAdd

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:882

### subTreeSum

- subTreeSum(subTreeRoot, propertyName?): number

- The function `subTreeSum` calculates the sum of a specified property in a binary tree or subtree.

  #### Parameters

  - ##### subTreeRoot: null | number | N

    The `subTreeRoot` parameter represents the root node of a binary tree or the ID of a binary tree node. It can also be `null` if there is no subtree.

  - ##### `Optional` propertyName: BinaryTreeNodePropertyName

    propertyName is an optional parameter that specifies the property of the binary tree node to use for calculating the sum. It can be either 'id' or 'val'. If propertyName is not provided, it defaults to 'id'.

  #### Returns number

  a number, which is the sum of the values of the specified property in the subtree rooted at `subTreeRoot`.

  Implementation of IAVLTree.subTreeSum

  Inherited from BST.subTreeSum

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:826

### swapLocation

- swapLocation(srcNode, destNode): N

- The `swapLocation` function swaps the location of two nodes in a binary tree.

  #### Parameters

  - ##### srcNode: N

    The source node that you want to swap with the destination node.

  - ##### destNode: N

    The `destNode` parameter represents the destination node where the values from `srcNode` will be swapped to.

  #### Returns N

  The `destNode` is being returned.

  Implementation of IAVLTree.swapLocation

  Inherited from BST.swapLocation

  - Defined in src/data-structures/binary-tree/abstract-binary-tree.ts:205

Generated using TypeDoc